"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SageMakerFeatureStoreRuntime = void 0;
const BatchGetRecordCommand_1 = require("./commands/BatchGetRecordCommand");
const DeleteRecordCommand_1 = require("./commands/DeleteRecordCommand");
const GetRecordCommand_1 = require("./commands/GetRecordCommand");
const PutRecordCommand_1 = require("./commands/PutRecordCommand");
const SageMakerFeatureStoreRuntimeClient_1 = require("./SageMakerFeatureStoreRuntimeClient");
class SageMakerFeatureStoreRuntime extends SageMakerFeatureStoreRuntimeClient_1.SageMakerFeatureStoreRuntimeClient {
    batchGetRecord(args, optionsOrCb, cb) {
        const command = new BatchGetRecordCommand_1.BatchGetRecordCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    deleteRecord(args, optionsOrCb, cb) {
        const command = new DeleteRecordCommand_1.DeleteRecordCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getRecord(args, optionsOrCb, cb) {
        const command = new GetRecordCommand_1.GetRecordCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    putRecord(args, optionsOrCb, cb) {
        const command = new PutRecordCommand_1.PutRecordCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
}
exports.SageMakerFeatureStoreRuntime = SageMakerFeatureStoreRuntime;
