"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_restJson1PutRecordCommand = exports.deserializeAws_restJson1GetRecordCommand = exports.deserializeAws_restJson1DeleteRecordCommand = exports.deserializeAws_restJson1BatchGetRecordCommand = exports.serializeAws_restJson1PutRecordCommand = exports.serializeAws_restJson1GetRecordCommand = exports.serializeAws_restJson1DeleteRecordCommand = exports.serializeAws_restJson1BatchGetRecordCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const models_0_1 = require("../models/models_0");
const SageMakerFeatureStoreRuntimeServiceException_1 = require("../models/SageMakerFeatureStoreRuntimeServiceException");
const serializeAws_restJson1BatchGetRecordCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/BatchGetRecord";
    let body;
    body = JSON.stringify({
        ...(input.Identifiers !== undefined &&
            input.Identifiers !== null && {
            Identifiers: serializeAws_restJson1BatchGetRecordIdentifiers(input.Identifiers, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchGetRecordCommand = serializeAws_restJson1BatchGetRecordCommand;
const serializeAws_restJson1DeleteRecordCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/FeatureGroup/{FeatureGroupName}";
    if (input.FeatureGroupName !== undefined) {
        const labelValue = input.FeatureGroupName;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: FeatureGroupName.");
        }
        resolvedPath = resolvedPath.replace("{FeatureGroupName}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: FeatureGroupName.");
    }
    const query = {
        ...(input.RecordIdentifierValueAsString !== undefined && {
            RecordIdentifierValueAsString: input.RecordIdentifierValueAsString,
        }),
        ...(input.EventTime !== undefined && { EventTime: input.EventTime }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1DeleteRecordCommand = serializeAws_restJson1DeleteRecordCommand;
const serializeAws_restJson1GetRecordCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/FeatureGroup/{FeatureGroupName}";
    if (input.FeatureGroupName !== undefined) {
        const labelValue = input.FeatureGroupName;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: FeatureGroupName.");
        }
        resolvedPath = resolvedPath.replace("{FeatureGroupName}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: FeatureGroupName.");
    }
    const query = {
        ...(input.RecordIdentifierValueAsString !== undefined && {
            RecordIdentifierValueAsString: input.RecordIdentifierValueAsString,
        }),
        ...(input.FeatureNames !== undefined && { FeatureName: (input.FeatureNames || []).map((_entry) => _entry) }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1GetRecordCommand = serializeAws_restJson1GetRecordCommand;
const serializeAws_restJson1PutRecordCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/FeatureGroup/{FeatureGroupName}";
    if (input.FeatureGroupName !== undefined) {
        const labelValue = input.FeatureGroupName;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: FeatureGroupName.");
        }
        resolvedPath = resolvedPath.replace("{FeatureGroupName}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: FeatureGroupName.");
    }
    let body;
    body = JSON.stringify({
        ...(input.Record !== undefined &&
            input.Record !== null && { Record: serializeAws_restJson1Record(input.Record, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1PutRecordCommand = serializeAws_restJson1PutRecordCommand;
const deserializeAws_restJson1BatchGetRecordCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchGetRecordCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Errors: undefined,
        Records: undefined,
        UnprocessedIdentifiers: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Errors !== undefined && data.Errors !== null) {
        contents.Errors = deserializeAws_restJson1BatchGetRecordErrors(data.Errors, context);
    }
    if (data.Records !== undefined && data.Records !== null) {
        contents.Records = deserializeAws_restJson1BatchGetRecordResultDetails(data.Records, context);
    }
    if (data.UnprocessedIdentifiers !== undefined && data.UnprocessedIdentifiers !== null) {
        contents.UnprocessedIdentifiers = deserializeAws_restJson1UnprocessedIdentifiers(data.UnprocessedIdentifiers, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchGetRecordCommand = deserializeAws_restJson1BatchGetRecordCommand;
const deserializeAws_restJson1BatchGetRecordCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessForbidden":
        case "com.amazonaws.sagemakerfeaturestoreruntime#AccessForbidden":
            throw await deserializeAws_restJson1AccessForbiddenResponse(parsedOutput, context);
        case "InternalFailure":
        case "com.amazonaws.sagemakerfeaturestoreruntime#InternalFailure":
            throw await deserializeAws_restJson1InternalFailureResponse(parsedOutput, context);
        case "ServiceUnavailable":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ServiceUnavailable":
            throw await deserializeAws_restJson1ServiceUnavailableResponse(parsedOutput, context);
        case "ValidationError":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ValidationError":
            throw await deserializeAws_restJson1ValidationErrorResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new SageMakerFeatureStoreRuntimeServiceException_1.SageMakerFeatureStoreRuntimeServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteRecordCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteRecordCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteRecordCommand = deserializeAws_restJson1DeleteRecordCommand;
const deserializeAws_restJson1DeleteRecordCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessForbidden":
        case "com.amazonaws.sagemakerfeaturestoreruntime#AccessForbidden":
            throw await deserializeAws_restJson1AccessForbiddenResponse(parsedOutput, context);
        case "InternalFailure":
        case "com.amazonaws.sagemakerfeaturestoreruntime#InternalFailure":
            throw await deserializeAws_restJson1InternalFailureResponse(parsedOutput, context);
        case "ServiceUnavailable":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ServiceUnavailable":
            throw await deserializeAws_restJson1ServiceUnavailableResponse(parsedOutput, context);
        case "ValidationError":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ValidationError":
            throw await deserializeAws_restJson1ValidationErrorResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new SageMakerFeatureStoreRuntimeServiceException_1.SageMakerFeatureStoreRuntimeServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetRecordCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetRecordCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Record: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Record !== undefined && data.Record !== null) {
        contents.Record = deserializeAws_restJson1Record(data.Record, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetRecordCommand = deserializeAws_restJson1GetRecordCommand;
const deserializeAws_restJson1GetRecordCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessForbidden":
        case "com.amazonaws.sagemakerfeaturestoreruntime#AccessForbidden":
            throw await deserializeAws_restJson1AccessForbiddenResponse(parsedOutput, context);
        case "InternalFailure":
        case "com.amazonaws.sagemakerfeaturestoreruntime#InternalFailure":
            throw await deserializeAws_restJson1InternalFailureResponse(parsedOutput, context);
        case "ResourceNotFound":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ResourceNotFound":
            throw await deserializeAws_restJson1ResourceNotFoundResponse(parsedOutput, context);
        case "ServiceUnavailable":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ServiceUnavailable":
            throw await deserializeAws_restJson1ServiceUnavailableResponse(parsedOutput, context);
        case "ValidationError":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ValidationError":
            throw await deserializeAws_restJson1ValidationErrorResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new SageMakerFeatureStoreRuntimeServiceException_1.SageMakerFeatureStoreRuntimeServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1PutRecordCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1PutRecordCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1PutRecordCommand = deserializeAws_restJson1PutRecordCommand;
const deserializeAws_restJson1PutRecordCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessForbidden":
        case "com.amazonaws.sagemakerfeaturestoreruntime#AccessForbidden":
            throw await deserializeAws_restJson1AccessForbiddenResponse(parsedOutput, context);
        case "InternalFailure":
        case "com.amazonaws.sagemakerfeaturestoreruntime#InternalFailure":
            throw await deserializeAws_restJson1InternalFailureResponse(parsedOutput, context);
        case "ServiceUnavailable":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ServiceUnavailable":
            throw await deserializeAws_restJson1ServiceUnavailableResponse(parsedOutput, context);
        case "ValidationError":
        case "com.amazonaws.sagemakerfeaturestoreruntime#ValidationError":
            throw await deserializeAws_restJson1ValidationErrorResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new SageMakerFeatureStoreRuntimeServiceException_1.SageMakerFeatureStoreRuntimeServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1AccessForbiddenResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.AccessForbidden({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1InternalFailureResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.InternalFailure({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ResourceNotFoundResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ResourceNotFound({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ServiceUnavailableResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ServiceUnavailable({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ValidationErrorResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ValidationError({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const serializeAws_restJson1BatchGetRecordIdentifier = (input, context) => {
    return {
        ...(input.FeatureGroupName !== undefined &&
            input.FeatureGroupName !== null && { FeatureGroupName: input.FeatureGroupName }),
        ...(input.FeatureNames !== undefined &&
            input.FeatureNames !== null && { FeatureNames: serializeAws_restJson1FeatureNames(input.FeatureNames, context) }),
        ...(input.RecordIdentifiersValueAsString !== undefined &&
            input.RecordIdentifiersValueAsString !== null && {
            RecordIdentifiersValueAsString: serializeAws_restJson1RecordIdentifiers(input.RecordIdentifiersValueAsString, context),
        }),
    };
};
const serializeAws_restJson1BatchGetRecordIdentifiers = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1BatchGetRecordIdentifier(entry, context);
    });
};
const serializeAws_restJson1FeatureNames = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1FeatureValue = (input, context) => {
    return {
        ...(input.FeatureName !== undefined && input.FeatureName !== null && { FeatureName: input.FeatureName }),
        ...(input.ValueAsString !== undefined && input.ValueAsString !== null && { ValueAsString: input.ValueAsString }),
    };
};
const serializeAws_restJson1Record = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1FeatureValue(entry, context);
    });
};
const serializeAws_restJson1RecordIdentifiers = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const deserializeAws_restJson1BatchGetRecordError = (output, context) => {
    return {
        ErrorCode: (0, smithy_client_1.expectString)(output.ErrorCode),
        ErrorMessage: (0, smithy_client_1.expectString)(output.ErrorMessage),
        FeatureGroupName: (0, smithy_client_1.expectString)(output.FeatureGroupName),
        RecordIdentifierValueAsString: (0, smithy_client_1.expectString)(output.RecordIdentifierValueAsString),
    };
};
const deserializeAws_restJson1BatchGetRecordErrors = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchGetRecordError(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1BatchGetRecordIdentifier = (output, context) => {
    return {
        FeatureGroupName: (0, smithy_client_1.expectString)(output.FeatureGroupName),
        FeatureNames: output.FeatureNames !== undefined && output.FeatureNames !== null
            ? deserializeAws_restJson1FeatureNames(output.FeatureNames, context)
            : undefined,
        RecordIdentifiersValueAsString: output.RecordIdentifiersValueAsString !== undefined && output.RecordIdentifiersValueAsString !== null
            ? deserializeAws_restJson1RecordIdentifiers(output.RecordIdentifiersValueAsString, context)
            : undefined,
    };
};
const deserializeAws_restJson1BatchGetRecordResultDetail = (output, context) => {
    return {
        FeatureGroupName: (0, smithy_client_1.expectString)(output.FeatureGroupName),
        Record: output.Record !== undefined && output.Record !== null
            ? deserializeAws_restJson1Record(output.Record, context)
            : undefined,
        RecordIdentifierValueAsString: (0, smithy_client_1.expectString)(output.RecordIdentifierValueAsString),
    };
};
const deserializeAws_restJson1BatchGetRecordResultDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchGetRecordResultDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1FeatureNames = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1FeatureValue = (output, context) => {
    return {
        FeatureName: (0, smithy_client_1.expectString)(output.FeatureName),
        ValueAsString: (0, smithy_client_1.expectString)(output.ValueAsString),
    };
};
const deserializeAws_restJson1Record = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1FeatureValue(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RecordIdentifiers = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1UnprocessedIdentifiers = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchGetRecordIdentifier(entry, context);
    });
    return retVal;
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
