import { __extends } from "tslib";
import { BatchGetRecordCommand, } from "./commands/BatchGetRecordCommand";
import { DeleteRecordCommand, } from "./commands/DeleteRecordCommand";
import { GetRecordCommand } from "./commands/GetRecordCommand";
import { PutRecordCommand } from "./commands/PutRecordCommand";
import { SageMakerFeatureStoreRuntimeClient } from "./SageMakerFeatureStoreRuntimeClient";
var SageMakerFeatureStoreRuntime = (function (_super) {
    __extends(SageMakerFeatureStoreRuntime, _super);
    function SageMakerFeatureStoreRuntime() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SageMakerFeatureStoreRuntime.prototype.batchGetRecord = function (args, optionsOrCb, cb) {
        var command = new BatchGetRecordCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    SageMakerFeatureStoreRuntime.prototype.deleteRecord = function (args, optionsOrCb, cb) {
        var command = new DeleteRecordCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    SageMakerFeatureStoreRuntime.prototype.getRecord = function (args, optionsOrCb, cb) {
        var command = new GetRecordCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    SageMakerFeatureStoreRuntime.prototype.putRecord = function (args, optionsOrCb, cb) {
        var command = new PutRecordCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    return SageMakerFeatureStoreRuntime;
}(SageMakerFeatureStoreRuntimeClient));
export { SageMakerFeatureStoreRuntime };
