import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchGetRecordRequest, BatchGetRecordResponse } from "../models/models_0";
import { deserializeAws_restJson1BatchGetRecordCommand, serializeAws_restJson1BatchGetRecordCommand, } from "../protocols/Aws_restJson1";
var BatchGetRecordCommand = (function (_super) {
    __extends(BatchGetRecordCommand, _super);
    function BatchGetRecordCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchGetRecordCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "SageMakerFeatureStoreRuntimeClient";
        var commandName = "BatchGetRecordCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchGetRecordRequest.filterSensitiveLog,
            outputFilterSensitiveLog: BatchGetRecordResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchGetRecordCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1BatchGetRecordCommand(input, context);
    };
    BatchGetRecordCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1BatchGetRecordCommand(output, context);
    };
    return BatchGetRecordCommand;
}($Command));
export { BatchGetRecordCommand };
