import { HttpHandlerOptions as __HttpHandlerOptions } from "@aws-sdk/types";
import { BatchGetRecordCommandInput, BatchGetRecordCommandOutput } from "./commands/BatchGetRecordCommand";
import { DeleteRecordCommandInput, DeleteRecordCommandOutput } from "./commands/DeleteRecordCommand";
import { GetRecordCommandInput, GetRecordCommandOutput } from "./commands/GetRecordCommand";
import { PutRecordCommandInput, PutRecordCommandOutput } from "./commands/PutRecordCommand";
import { SageMakerFeatureStoreRuntimeClient } from "./SageMakerFeatureStoreRuntimeClient";

export declare class SageMakerFeatureStoreRuntime extends SageMakerFeatureStoreRuntimeClient {
    
    batchGetRecord(args: BatchGetRecordCommandInput, options?: __HttpHandlerOptions): Promise<BatchGetRecordCommandOutput>;
    batchGetRecord(args: BatchGetRecordCommandInput, cb: (err: any, data?: BatchGetRecordCommandOutput) => void): void;
    batchGetRecord(args: BatchGetRecordCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: BatchGetRecordCommandOutput) => void): void;
    
    deleteRecord(args: DeleteRecordCommandInput, options?: __HttpHandlerOptions): Promise<DeleteRecordCommandOutput>;
    deleteRecord(args: DeleteRecordCommandInput, cb: (err: any, data?: DeleteRecordCommandOutput) => void): void;
    deleteRecord(args: DeleteRecordCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: DeleteRecordCommandOutput) => void): void;
    
    getRecord(args: GetRecordCommandInput, options?: __HttpHandlerOptions): Promise<GetRecordCommandOutput>;
    getRecord(args: GetRecordCommandInput, cb: (err: any, data?: GetRecordCommandOutput) => void): void;
    getRecord(args: GetRecordCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: GetRecordCommandOutput) => void): void;
    
    putRecord(args: PutRecordCommandInput, options?: __HttpHandlerOptions): Promise<PutRecordCommandOutput>;
    putRecord(args: PutRecordCommandInput, cb: (err: any, data?: PutRecordCommandOutput) => void): void;
    putRecord(args: PutRecordCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: PutRecordCommandOutput) => void): void;
}
