import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { BatchGetRecordRequest, BatchGetRecordResponse } from "../models/models_0";
import { SageMakerFeatureStoreRuntimeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../SageMakerFeatureStoreRuntimeClient";
export interface BatchGetRecordCommandInput extends BatchGetRecordRequest {
}
export interface BatchGetRecordCommandOutput extends BatchGetRecordResponse, __MetadataBearer {
}

export declare class BatchGetRecordCommand extends $Command<BatchGetRecordCommandInput, BatchGetRecordCommandOutput, SageMakerFeatureStoreRuntimeClientResolvedConfig> {
    readonly input: BatchGetRecordCommandInput;
    constructor(input: BatchGetRecordCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: SageMakerFeatureStoreRuntimeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchGetRecordCommandInput, BatchGetRecordCommandOutput>;
    private serialize;
    private deserialize;
}
