import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { GetRecordRequest, GetRecordResponse } from "../models/models_0";
import { SageMakerFeatureStoreRuntimeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../SageMakerFeatureStoreRuntimeClient";
export interface GetRecordCommandInput extends GetRecordRequest {
}
export interface GetRecordCommandOutput extends GetRecordResponse, __MetadataBearer {
}

export declare class GetRecordCommand extends $Command<GetRecordCommandInput, GetRecordCommandOutput, SageMakerFeatureStoreRuntimeClientResolvedConfig> {
    readonly input: GetRecordCommandInput;
    constructor(input: GetRecordCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: SageMakerFeatureStoreRuntimeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetRecordCommandInput, GetRecordCommandOutput>;
    private serialize;
    private deserialize;
}
