import { ExceptionOptionType as __ExceptionOptionType } from "@aws-sdk/smithy-client";
import { SageMakerFeatureStoreRuntimeServiceException as __BaseException } from "./SageMakerFeatureStoreRuntimeServiceException";

export declare class AccessForbidden extends __BaseException {
    readonly name: "AccessForbidden";
    readonly $fault: "client";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<AccessForbidden, __BaseException>);
}

export interface BatchGetRecordIdentifier {
    
    FeatureGroupName: string | undefined;
    
    RecordIdentifiersValueAsString: string[] | undefined;
    
    FeatureNames?: string[];
}
export declare namespace BatchGetRecordIdentifier {
    
    const filterSensitiveLog: (obj: BatchGetRecordIdentifier) => any;
}
export interface BatchGetRecordRequest {
    
    Identifiers: BatchGetRecordIdentifier[] | undefined;
}
export declare namespace BatchGetRecordRequest {
    
    const filterSensitiveLog: (obj: BatchGetRecordRequest) => any;
}

export interface BatchGetRecordError {
    
    FeatureGroupName: string | undefined;
    
    RecordIdentifierValueAsString: string | undefined;
    
    ErrorCode: string | undefined;
    
    ErrorMessage: string | undefined;
}
export declare namespace BatchGetRecordError {
    
    const filterSensitiveLog: (obj: BatchGetRecordError) => any;
}

export interface FeatureValue {
    
    FeatureName: string | undefined;
    
    ValueAsString: string | undefined;
}
export declare namespace FeatureValue {
    
    const filterSensitiveLog: (obj: FeatureValue) => any;
}

export interface BatchGetRecordResultDetail {
    
    FeatureGroupName: string | undefined;
    
    RecordIdentifierValueAsString: string | undefined;
    
    Record: FeatureValue[] | undefined;
}
export declare namespace BatchGetRecordResultDetail {
    
    const filterSensitiveLog: (obj: BatchGetRecordResultDetail) => any;
}
export interface BatchGetRecordResponse {
    
    Records: BatchGetRecordResultDetail[] | undefined;
    
    Errors: BatchGetRecordError[] | undefined;
    
    UnprocessedIdentifiers: BatchGetRecordIdentifier[] | undefined;
}
export declare namespace BatchGetRecordResponse {
    
    const filterSensitiveLog: (obj: BatchGetRecordResponse) => any;
}

export declare class InternalFailure extends __BaseException {
    readonly name: "InternalFailure";
    readonly $fault: "server";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<InternalFailure, __BaseException>);
}

export declare class ServiceUnavailable extends __BaseException {
    readonly name: "ServiceUnavailable";
    readonly $fault: "server";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<ServiceUnavailable, __BaseException>);
}

export declare class ValidationError extends __BaseException {
    readonly name: "ValidationError";
    readonly $fault: "client";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<ValidationError, __BaseException>);
}
export interface DeleteRecordRequest {
    
    FeatureGroupName: string | undefined;
    
    RecordIdentifierValueAsString: string | undefined;
    
    EventTime: string | undefined;
}
export declare namespace DeleteRecordRequest {
    
    const filterSensitiveLog: (obj: DeleteRecordRequest) => any;
}
export interface GetRecordRequest {
    
    FeatureGroupName: string | undefined;
    
    RecordIdentifierValueAsString: string | undefined;
    
    FeatureNames?: string[];
}
export declare namespace GetRecordRequest {
    
    const filterSensitiveLog: (obj: GetRecordRequest) => any;
}
export interface GetRecordResponse {
    
    Record?: FeatureValue[];
}
export declare namespace GetRecordResponse {
    
    const filterSensitiveLog: (obj: GetRecordResponse) => any;
}

export declare class ResourceNotFound extends __BaseException {
    readonly name: "ResourceNotFound";
    readonly $fault: "client";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<ResourceNotFound, __BaseException>);
}
export interface PutRecordRequest {
    
    FeatureGroupName: string | undefined;
    
    Record: FeatureValue[] | undefined;
}
export declare namespace PutRecordRequest {
    
    const filterSensitiveLog: (obj: PutRecordRequest) => any;
}
